@echo off

CLS
set errno=1
set FileConst=HWA_0002_001_SB
set PackConst=%FileConst%_SM1200_High_Speed
set PackFixname=HW add-on %PackConst%
set Logfixname=HW_add-on_%PackConst%_V10.5.log
set WaitText=Please wait until the installation is finished ...



IF not "%OS%"=="Windows_NT" echo Error Wrong operating system
IF not "%OS%"=="Windows_NT" echo goto Ende

set Header=Siemens Automation: Installing Hardware add-ons for TIA Portal V10.5 ...

VERIFY CMDProbs	 2>nul
SETLOCAL ENABLEEXTENSIONS
IF ERRORLEVEL 1 echo Error! Unable to enable batch extensions!
IF ERRORLEVEL 1 GOTO Ende
rem SETLOCAL DISABLEDELAYEDEXPANSION

echo %Header%
echo.
echo If you start from a network path, maybe it will take some seconds..
:: Make it possible to start from UNC paths too:
PUSHD "%~dp0"
REM Deleting Unc Message texts
CLS
echo %Header%
echo.

set MyPath=%CD%
rem echo Temporary working path: %MyPath%


:: === Security Tests and Logging Initialization ================================================================

echo Preparation..
echo.

IF NOT DEFINED APPDATA (set APPDATA=dummy)

CALL :LOGGINGSUB "%APPDATA%" %*

set RightsOK=1
set tmpfil="%WINDIR%\deletable_%RANDOM%_%RANDOM%.tmp"
rem set tmpfil=%WINDIR%\deletable_%RANDOM%%RANDOM%_%DATE%:.tmp
echo For testing, file can be deleted without problems >%tmpfil% 2>nul
if exist %tmpfil% (
   DEL /Q /F %tmpfil% >nul 2>nul
   if errorlevel 1 set RightsOK=0

) else ( set RightsOK=0 )

rem echo %tmpfil%
rem echo RightOK: %RightsOK%

set errnosec=0
set LOGFILE="%LOGFILEDIR%%LOGFILENAME%"
echo.
rem echo Logfilename: %LOGFILE%
rem Tip: From here on without parantheses
echo. >%LOGFILE% 2>nul
if errorlevel 1 set /A errnosec=%errnosec%+1
DEL /Q /F %LOGFILE% >nul 2>nul
if errorlevel 1 set /A errnosec=%errnosec%+2


echo %Header% >%LOGFILE% 2>nul
echo. >>%LOGFILE% 2>nul

if not exist %LOGFILE% set /A errnosec=%errnosec%+4

if %errnosec% GTR 0 (
   color cf
   echo.
   echo Error!
   echo Problems while creating a file! Error no.: %errnosec%
   echo.
   echo Security problems assumed. Aborting installation!
   echo.
   echo Please look, if the following file exists and copy it for support: %Logfile%
   color 0f
   EXIT /B %errnosec%
)

REM Log date and time of batch execution
echo === Started: %DATE%  %TIME% >>%LOGFILE%
echo. >>%LOGFILE%
echo - Current Logfile: %LOGFILE% >>%LOGFILE%
echo. >>%LOGFILE%
echo - Temporary working path: %MyPath% >>%LOGFILE%
echo. >>%LOGFILE%
echo - Rights elevated? %RightsOK% >>%LOGFILE% 
echo. >>%LOGFILE%
echo  Temp.file : %tmpfil% >>%LOGFILE%
echo. >>%LOGFILE%

:: === Determining PE version ===================================================================================

echo - Determining PE-version: >>%LOGFILE% 2>&1

call :REGVALUESUB HKLM\SOFTWARE\Siemens\Automation\_InstalledSW\TIAP10\EditionMain Version

set PLATFORM_INSTALL_VERS=%regvalue%
IF "%PLATFORM_INSTALL_VERS%" LSS "10.05.0000" (
    set errmsg1=SIMATIC STEP7 V10.5 with TIA Portal not found! Installation aborted.
    set errmsg2=Please restart, when you have STEP 7 V10.5 installed.
    goto ERR_ABORT
)

rem echo "%PLATFORM_INSTALL_VERS%"
echo Platform Install version: "%PLATFORM_INSTALL_VERS%" >>%LOGFILE%
echo. >>%LOGFILE%


:: === HW-Collector Installation ================================================================================

echo - Determining HW-Collector >>%LOGFILE% 2>&1
call :REGVALUESUB HKLM\SOFTWARE\Siemens\Automation\_InstalledSW\TIAP10\HWCN-HWCOL Version

set HWCOLVERS=%regvalue%
IF "%HWCOLVERS%"=="" (set HWCOLEXIST=0) else (set HWCOLEXIST=1)
echo HWCOL version: %HWCOLVERS% >>%LOGFILE%
echo HWCOL existing?: %HWCOLEXIST% >>%LOGFILE%

rem echo %HWCOLVERS%
rem echo %HWCOLEXIST%

echo.
echo Installation starting..
echo %WaitText%
echo.

set cmdln=msiexec.exe /i "%MyPath%\HWCOL\Media\HWCN-HWCOL.msi" ADS_SIA=1 /qb /L*v "%autinstlog%\HWCN-HWCOL_TIAP10_Setup_SP1.log"

rem Assure correct HWCOL version
if /I "%HWCOLVERS%" GEQ "10.05.0001" goto hwaddon 

   echo HWCOL installation with admin rights necessary. >>%LOGFILE%
   if not "%RightsOK%"=="1" (
      set errmsg1=Admin rights are necessary to proceed with the installation!
      set errmsg2=Please restart again with correct rights.
      goto ERR_ABORT
   )
   echo - Starting HWCOL installation: %cmdln% >>%LOGFILE%
   %cmdln%

   rem 2nd test of HWCOL version, optional repair
   call :REGVALUESUB HKLM\SOFTWARE\Siemens\Automation\_InstalledSW\TIAP10\HWCN-HWCOL Version
   set HWCOLVERS=%regvalue%
   echo HWCOL version afterwards: %HWCOLVERS% >>%LOGFILE%
   echo.
   echo Installation starting..
   echo %WaitText%
   echo.


   if /I "%HWCOLVERS%" GEQ "10.05.0001" goto hwaddon

      set cmdln=%cmdln% REINSTALL=ALL REINSTALLMODE=vemus
      echo HWCOL install was not successful. >>%LOGFILE%
      echo - Trying HWCOL repair: %cmdln% >>%LOGFILE%
      %cmdln%

      rem 3rd and final test of HWCOL version
      call :REGVALUESUB HKLM\SOFTWARE\Siemens\Automation\_InstalledSW\TIAP10\HWCN-HWCOL Version
      echo.
      echo Installation starting..
      echo %WaitText%
      echo.

      set HWCOLVERS=%regvalue%
      echo HWCOL version finally: %HWCOLVERS% >>%LOGFILE%
      if /I "%HWCOLVERS%" LSS "10.05.0001" (
         set errmsg1=An error occured while installing HW Module Base Package.
         set errmsg2=Maybe admin rights missing for this setup. Please restart with admin rights!
         goto ERR_ABORT
      )
rem pseudo endif (to avoid delayed expansion for this block)
   

:: === Installation of HW-addon(s) ==============================================================================

:hwaddon

echo HWCOL version correct. >>%LOGFILE%
set specialparam=ADS_SIA
rem set specialparam=INSTALLALLOWED


set msplog=%autinstlog%\%Logfixname%
set cmdln=msiexec.exe /Update "%MyPath%\UPD\HWCN-HWCOL.msp;%MyPath%\SUPP\%FileConst%.msp" %specialparam%=1 AVOIDSTARTAPPL=1 /qb /L*v "%msplog%"
rem If helpfiles are in hwaddon, use INSTALLALLOWED=1
echo. >>%LOGFILE%
echo - Starting HW-addon installation: %cmdln% >>%LOGFILE%
%cmdln%
if errorlevel 1 (
   set errmsg1=Failure during %PackFixname% installation occured!
   set errmsg2=For problem analysis the logfile '%msplog%' is necessary.
   goto ERR_ABORT
)


:: === Successful Exit ==========================================================================================

CLS
color 2f
echo %Header%
echo.
echo.
echo.
echo The Installation finished successfully.
echo.
echo.>>%LOGFILE%
echo === The Installation finished successfully: %DATE%  %TIME% >>%LOGFILE%
set errno=0
if not "%~1"=="-nopause" pause
color
EXIT /B 0
rem Time estimation: If V10.5 SP1 or higher installed, 5-20 secs; for V10.5 release, 30 seconds, if help files involved, + 2 min.
goto Ende

:: === Error Exit ===============================================================================================

:ERR_ABORT
CLS
color cf
echo %Header%
echo.
echo ERROR ENCOUNTERED:
echo.
echo %errmsg1%
echo %errmsg2%

if exist %logfile% (
   echo.
   echo.>>%LOGFILE%
   echo Error encountered: %* >>%LOGFILE%
   echo %errmsg1% >>%LOGFILE%
   echo %errmsg2% >>%LOGFILE%
   echo A logfile is provided here:
   echo   %LOGFILE%
   echo.
   echo.>>%LOGFILE%
   echo === Aborted with error: %DATE%  %TIME% >>%LOGFILE%
)

echo.
if not "%~1"=="-nopause" pause
color
EXIT /B 1


:: === LOGGING Subroutine =======================================================================================
:LOGGINGSUB
set APPDATADIR=%~nx1
set NAME=%~n0
SHIFT


rem Define %TIMESTAMP% for use in logfilename
rem TIMESTAMP = DATE and TIME w/o last 3 chars (hs)
set TIMESTAMP=%DATE%_%TIME:~0,-3%
rem replace : by -
set TIMESTAMP=%TIMESTAMP::=-%
rem replace . by -
set TIMESTAMP=%TIMESTAMP:.=-%
rem replace ' ' by -
set TIMESTAMP=%TIMESTAMP: =-%
rem replace '/' by -
set TIMESTAMP=%TIMESTAMP:/=-%

rem Define the logfile path and name here. 
if not defined AUTINSTLOG (
   set LOGFILEDIR=%ALLUSERSPROFILE%\%APPDATADIR%\Siemens\Automation\Logfiles\Setup\
) else (
   set LOGFILEDIR=%AUTINSTLOG%
)

if not exist "%LOGFILEDIR%" set LOGFILEDIR=%MyPath%
set AUTINSTLOG=%LOGFILEDIR%

rem Use %TIMESTAMP% to separate logfile
set LOGFILENAME=%NAME%_%TIMESTAMP%.log
goto :EOF


:: === REGVALUE read Subroutine =======================================================================================
:REGVALUESUB

set testkey=%1
set testvalue=%2
shift 2
set regvalue=

echo Reading registry value '%testvalue%' in key '%testkey%' >>%LOGFILE% 2>&1


FOR /f "eol=[ skip=2 tokens=1,2*" %%I in ('reg.exe query %testkey% /v %testvalue%') DO (
   if %%I==%testvalue% (
       set regvalue=%%K
   )
)
CLS
echo %Header%
echo.
@rem cls here avoids unwanted warning texts of reg.exe


IF NOT DEFINED regvalue echo Registry value not found >>%LOGFILE% 2>&1
IF "%regvalue%"=="" 	echo Registry value not found >>%LOGFILE% 2>&1
goto :eof


:Ende
ENDLOCAL
pause
EXIT /B %errno%
